"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BtnEdit = exports.BtnBack = exports.BtnAction = void 0;
const react_1 = __importDefault(require("react"));
const btn_1 = __importDefault(require("./btn"));
const icon_1 = __importDefault(require("../icon"));
const actionToIcon = (action) => {
    switch (action) {
        case "back":
            return "arrow-left";
        default:
            return action;
    }
};
const actionToText = (action) => {
    switch (action) {
        case "back":
            return "Back";
        case "edit":
            return "Edit";
        default:
            return action;
    }
};
const BtnAction = ({ link, onClick, action, }) => {
    const content = (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(icon_1.default, { name: actionToIcon(action) }),
        " ",
        actionToText(action)));
    return (react_1.default.createElement(btn_1.default, { onClick: onClick, link: link }, content));
};
exports.BtnAction = BtnAction;
const BtnBack = ({ link, onClick }) => (react_1.default.createElement(exports.BtnAction, { action: "back", onClick: onClick, link: link }));
exports.BtnBack = BtnBack;
const BtnEdit = ({ link, onClick, }) => react_1.default.createElement(exports.BtnAction, { action: "edit", onClick: onClick, link: link });
exports.BtnEdit = BtnEdit;
exports.default = exports.BtnAction;
