"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const toggle_1 = __importDefault(require("../toggle"));
const view_1 = __importDefault(require("../view"));
const edit_1 = __importDefault(require("../edit"));
const delete_1 = __importDefault(require("../delete"));
const DetailWExtras = (title, Form, viewFields, { update, detail, deleteById, getOptions }, redirectUrl, showToggle = true, detailColWidth = 6, extras) => {
    const [data, setData] = react_1.default.useState("null");
    // merge different promises to have all in the same functions
    const detailWOptions = async (id) => {
        const data = await detail(id);
        const options = getOptions
            ? await getOptions()
            : new Map();
        return { data, options };
    };
    const Delete = deleteById
        ? delete_1.default(deleteById, redirectUrl)
        : () => react_1.default.createElement(react_1.default.Fragment, null);
    // define final view based on options chosen
    const Main = getMain(showToggle, viewFields, Form, redirectUrl, update);
    getOptions && getOptions();
    return ({ id }) => {
        if (!isData(data)) {
            detailWOptions(id).then((data) => setData(data));
        }
        return (react_1.default.createElement("div", { className: "row" },
            react_1.default.createElement("div", { className: "col-md-" + detailColWidth },
                react_1.default.createElement("h2", null, title),
                isData(data) ? (react_1.default.createElement(Main, { id: id, data: data.data, formOptions: data.options })) : (react_1.default.createElement(react_1.default.Fragment, null, "loading")),
                "\u00A0",
                react_1.default.createElement(Delete, { id: id })),
            extras &&
                extras.map((ExtraUnit, i) => isData(data) ? (react_1.default.createElement("div", { key: i, className: `col-md-${ExtraUnit.colSpan || 6}` },
                    react_1.default.createElement(ExtraUnit.Component, { data: data.data }))) : (react_1.default.createElement(react_1.default.Fragment, null, "loading")))));
    };
};
const isData = (d) => d !== "null";
const getMain = (showToggle, viewFields, Form, redirectUrl, update) => {
    const View = view_1.default(viewFields);
    if (!update) {
        return View;
    }
    const Edit = edit_1.default(Form, update, redirectUrl);
    if (showToggle) {
        return toggle_1.default(Edit, View);
    }
    return Edit;
};
exports.default = DetailWExtras;
