"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InputNumberGeneric = void 0;
const react_1 = __importDefault(require("react"));
const utils_1 = require("./utils");
/**
 *
 * @param UI
 * @param acceptNumericValue // by default accept decimal values, this function here can be replaced with amything
 * @returns
 */
const InputNumberGeneric = (UI, acceptNumericValue = utils_1.acceptDecimalValue) => (p) => {
    const [value, setValue] = react_1.default.useState(p.value ? p.value.toString() : "");
    const handleChange = (s) => {
        if (s === undefined || s === "") {
            p.onChange(undefined);
            return;
        }
        const v = Number(s);
        if (acceptNumericValue(s)) {
            setValue(s);
        }
        if (!isNaN(v)) {
            p.onChange(v);
        }
    };
    return (react_1.default.createElement(UI, { disabled: p.disabled, placeholder: p.placeholder, value: value, onChange: handleChange, errors: p.errors }));
};
exports.InputNumberGeneric = InputNumberGeneric;
