"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const number_1 = require("../generic/number");
const InputUI = ({ value, onChange, errors, disabled, placeholder } // here string because the conversion to `number` happens at the outer level (generic component)
) => (react_1.default.createElement("input", { className: "form-control" + (errors && errors.length > 0 ? "  is-invalid" : ""), disabled: disabled, placeholder: placeholder, type: "text" // do not use number because it has issues with decimal numbers
    , value: value, onChange: (v) => onChange(v.target.value) }));
const InputNumber = number_1.InputNumberGeneric(InputUI);
exports.default = InputNumber;
