/// <reference types="react" />
import { FormOptionsMap } from "../form/type";
export declare type ColWidth = 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12;
export declare type ParamType = "number" | "string";
export interface CrudRequestDetail<A, Id> {
    detail: (id: Id) => Promise<A>;
    update?: (data: Partial<A>, id: Id) => Promise<void>;
    deleteById?: (id: Id) => Promise<boolean>;
    getOptions?: () => Promise<FormOptionsMap<A>>;
}
export interface DetailLayoutProps<Id> {
    backUrl?: string;
    Detail: ({ id }: {
        id: Id;
    }) => JSX.Element;
}
