"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const Validation = __importStar(require("@nexys/validation"));
const FormGeneratorWithoutDef = (FormUI, validator) => ({ onSuccess, isLoading = false, valueDefault = {}, errors: errorsDefault, }) => {
    const [data, setData] = react_1.default.useState(valueDefault);
    const [errors, setErrors] = react_1.default.useState(errorsDefault);
    react_1.default.useEffect(() => {
        setErrors(errorsDefault);
    }, [errorsDefault]);
    const handleSubmit = (event) => {
        event.preventDefault();
        // if validator is defined, do client side check
        // else simply invoke onSuccess
        if (validator) {
            const v = Validation.Main.checkObject(data, validator);
            // console.log(v);
            setErrors(v);
            // no errors found
            if (Object.values(v).length === 0) {
                //
                //alert(JSON.stringify(v));
                onSuccess(data);
            }
        }
        else {
            onSuccess(data);
        }
    };
    //console.log({ errors });
    return (react_1.default.createElement("form", { onSubmit: handleSubmit },
        react_1.default.createElement(FormUI, { errors: errors, data: data, disabled: isLoading, onChange: (name, value) => setData({ ...data, [name]: value }) })));
};
exports.default = FormGeneratorWithoutDef;
