"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const FormGenericUI = (formDef, Wrapper, BtnSubmit, FormUnit) => ({ data, errors, onChange, disabled }) => {
    return (react_1.default.createElement(react_1.default.Fragment, null,
        formDef.map((fd, i) => {
            const name = fd.name;
            const errorUnit = errors && errors[name];
            //console.log(name, errorUnit);
            return (react_1.default.createElement(Wrapper, { errors: errorUnit, key: i, label: fd.label },
                react_1.default.createElement(FormUnit, { type: fd.uiType, errors: errorUnit, value: data[fd.name], onChange: (v) => onChange(fd.name, v), options: fd.options, disabled: disabled })));
        }),
        react_1.default.createElement(BtnSubmit, { isLoading: disabled })));
};
exports.default = FormGenericUI;
