"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateValidatorFromDef = exports.uiTypeToVType = exports.getValue = void 0;
const type_1 = require("./type");
const getValue = (v) => {
    if (v === "" || v === undefined || v === null) {
        return undefined;
    }
    const vn = Number(v);
    if (isNaN(vn)) {
        return v;
    }
    return vn;
};
exports.getValue = getValue;
const uiTypeToVType = (t) => {
    switch (t) {
        case type_1.FormType.Number:
        case type_1.FormType.Select:
            return "number";
        case type_1.FormType.SelectObject:
            return "object";
        case type_1.FormType.Text:
            return "string";
        case type_1.FormType.Switch:
            return "boolean";
    }
};
exports.uiTypeToVType = uiTypeToVType;
const generateValidatorFromDef = (df) => {
    const v = {};
    df.forEach((f) => {
        v[f.name] = {
            optional: f.optional,
            type: exports.uiTypeToVType(f.uiType),
        };
    });
    return v;
};
exports.generateValidatorFromDef = generateValidatorFromDef;
