"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Loader = exports.PopoverFilter = exports.GlobalSearch = exports.FilterUnit = exports.RecordInfo = exports.ListBody = exports.ListHeader = exports.Row = exports.ListContainer = exports.ListWrapper = exports.OrderController = exports.OrderControllerUpAndDown = exports.HeaderUnit = exports.ColCell = exports.PaginationUnit = exports.PaginationWrapper = exports.NoRow = void 0;
const react_1 = __importDefault(require("react"));
const UIType = __importStar(require("@nexys/core-list"));
const loader_1 = __importDefault(require("../../loader"));
const Loader = () => react_1.default.createElement(loader_1.default, null);
exports.Loader = Loader;
const { paginationBoundaries } = UIType.PaginationUtils;
const Alert = ({ children, }) => react_1.default.createElement("div", { className: "alert" }, children);
const GlobalSearch = (p) => (react_1.default.createElement("div", { className: "row" },
    react_1.default.createElement("div", { className: "col-md-3" },
        react_1.default.createElement("input", { placeholder: "Search", type: "text", className: "form-control", onChange: (x) => p.onChange({ name: "globalSearch", value: x.target.value }) }))));
exports.GlobalSearch = GlobalSearch;
const PopoverFilter = () => react_1.default.createElement(react_1.default.Fragment, null);
exports.PopoverFilter = PopoverFilter;
const FilterUnit = () => react_1.default.createElement(react_1.default.Fragment, null);
exports.FilterUnit = FilterUnit;
const NoRow = (props) => {
    if (props.n > 0) {
        return null;
    }
    return react_1.default.createElement(Alert, { type: "warning" }, "No rows found");
};
exports.NoRow = NoRow;
const PaginationWrapper = (props) => {
    return (react_1.default.createElement("nav", null,
        react_1.default.createElement("ul", { className: "pagination" }, props.children)));
};
exports.PaginationWrapper = PaginationWrapper;
const PaginationUnit = (props) => {
    const { isActive, isDisabled, children, onClick } = props;
    // here we disable the button in case it is not valid
    if (isDisabled) {
        return null;
    }
    const className = "page-item" + (isActive ? " active" : "") + (isDisabled ? " disabled" : "");
    return (react_1.default.createElement("li", { className: className },
        react_1.default.createElement("button", { className: "page-link", onClick: onClick }, children)));
};
exports.PaginationUnit = PaginationUnit;
const ColCell = (props) => {
    const { children, colSpan, style } = props;
    return (react_1.default.createElement("td", { colSpan: colSpan, style: style }, children));
};
exports.ColCell = ColCell;
const HeaderUnit = (props) => {
    const { children } = props;
    return react_1.default.createElement("th", null, children);
};
exports.HeaderUnit = HeaderUnit;
const Icon = ({ name }) => react_1.default.createElement("i", { className: "fa fa-" + name });
const OrderControllerUpAndDown = (props) => {
    return (react_1.default.createElement("span", null,
        react_1.default.createElement("span", { key: "asc", onClick: () => props.onClick(true) },
            react_1.default.createElement(ChevronUp, null)),
        react_1.default.createElement("span", { key: "desc", onClick: () => props.onClick(false) },
            react_1.default.createElement(ChevronDown, null))));
};
exports.OrderControllerUpAndDown = OrderControllerUpAndDown;
const ChevronUp = () => react_1.default.createElement(Icon, { name: "chevron-up" });
const ChevronDown = () => react_1.default.createElement(Icon, { name: "chevron-down" });
const SortDefault = () => react_1.default.createElement(Icon, { name: "arrow" });
const OrderController = (props) => {
    const { onClick, descAsc } = props;
    let Icon = SortDefault;
    if (descAsc !== null) {
        Icon = descAsc ? ChevronUp : ChevronDown;
    }
    return (react_1.default.createElement("div", { style: {
            cursor: "pointer",
            display: "inline-block",
            color: descAsc === null ? "#ccc" : "#000",
        }, onClick: () => onClick(null) },
        react_1.default.createElement(Icon, null)));
};
exports.OrderController = OrderController;
const ListWrapper = ({ children }) => (react_1.default.createElement("div", { className: "table-responsive-sm" }, children));
exports.ListWrapper = ListWrapper;
const ListContainer = ({ children, maxHeight, }) => (react_1.default.createElement("div", { className: "container", style: maxHeight ? { maxHeight } : undefined },
    react_1.default.createElement("table", { className: "table table-striped" }, children)));
exports.ListContainer = ListContainer;
const Row = ({ children }) => react_1.default.createElement("tr", null, children);
exports.Row = Row;
const ListHeader = ({ children }) => (react_1.default.createElement("thead", null, children));
exports.ListHeader = ListHeader;
const ListBody = ({ children }) => (react_1.default.createElement("tbody", null, children));
exports.ListBody = ListBody;
const RecordInfo = (props) => {
    const { nPerPage, idx, n } = props;
    if (n === 0) {
        return null;
    }
    const { start, end } = paginationBoundaries(idx, nPerPage);
    return (react_1.default.createElement("p", { className: "pull-right" },
        "Showing ",
        start + 1,
        " to ",
        Number(start) + Number(nPerPage) > n ? n : end,
        " of",
        " ",
        n,
        " entries"));
};
exports.RecordInfo = RecordInfo;
